Part ShapeFromMesh/de: Difference between revisions

From FreeCAD Documentation
(Updating to match new version of source page)
(Updating to match new version of source page)
Line 14: Line 14:


==Introduction==
==Introduction==

The {{Button|[[Image:Part_ShapeFromMesh.svg|16px]] [[Part ShapeFromMesh|Part ShapeFromMesh]]}} command creates a shape from a [[Glossary#Mesh|mesh object]]. Mesh objects have limited editing capabilities in FreeCAD, converting them to shapes will allow their use with many more tools in FreeCAD (see [[#Notes|Notes]]).
The {{Button|[[Image:Part_ShapeFromMesh.svg|16px]] [[Part_ShapeFromMesh|Part ShapeFromMesh]]}} command creates a shape from a [[Mesh|mesh object]]. Mesh objects have limited editing capabilities in FreeCAD, converting them to [[Shape|shapes]] will allow their use with many more tools in FreeCAD.


==Usage==
==Usage==
# Select the mesh object.
# Choose {{MenuCommand|Part → [[Image:Part_ShapeFromMesh.svg|16px]] Create shape from mesh}} from the top menu.
# A popup-menu will ask for the tolerance for sewing shape (default value: 0,1)
# A shape from the mesh object is created as a separate new object.


# Select the mesh object in the [[tree_view|tree view]].
==Limitations==
# Go to the menu, {{MenuCommand|Part → [[File:Part_ShapeFromMesh.svg|16px]] Create shape from mesh}}.
There will be no analyzing or validating of the mesh object.
# A popup-menu will ask for the tolerance for sewing shape; the default value is {{Value|0.1}}.
# A [[Shape|shape]] from the mesh object is created as a separate new object.


Analyzing and repairing of the mesh (if needed) should be done manually before conversion.
Analyzing and repairing of the mesh, if needed, should be done manually before launching {{Button|[[File:Part_ShapeFromMesh.svg|16px]] [[Part_ShapeFromMesh|ShapeFromMesh]]}}. Appropriate tools for this task are available in the [[File:Workbench_Mesh.svg|24px]] [[Mesh_Workbench|Mesh Workbench]].


After creation of a [[Shape|Shape]], it may be useful to use {{Button|[[Part_ConvertToSolid|Convert to solid]]}} (necessary for [[Part_Boolean|boolean operations]]) and {{Button|[[File:Part_RefineShape.svg|16px]] [[Part_RefineShape|Refine shape]]}}.
Appropriate tools are available in the {{KEY|[[Image:Workbench_Mesh.svg|16px]] [[Mesh Workbench|Mesh Workbench]]}}


==Notes==
== Links ==

After creation of a shape, it may be useful to use [[Part ConvertToSolid|Convert to solid]] (necessary for [[Glossary#Boolean Operation|Boolean operations]]) and [[Image:Part_RefineShape.svg|24px]] [[Part RefineShape|Refine shape]] tools.
* [https://www.youtube.com/watch?v=5lwENZeNiNg&feature=youtu.be Edit STL Files In FreeCAD] video by AllVisuals4U.


==Scripting==
==Scripting==

Creating a [[Shape|Shape]] from a [[Mesh|Mesh]] can be done by using the {{incode|makeShapeFromMesh}} method from a [[Part_TopoShape|Part TopoShape]]; you need to specify the source mesh and tolerance, and assign the result to a new [[Part_Feature|Part Feature]] object.

Notice that the mesh must be recalculated before it is converted to a Shape, otherwise there won't be topology information, and the conversion won't be successful.

{{Code|code=
import FreeCAD as App
import Part

doc = App.newDocument()
mesh = doc.addObject("Mesh::Cube", "Mesh")
mesh.recompute()

solid = doc.addObject("Part::Feature", "Shape")
shape = Part.Shape()
shape.makeShapeFromMesh(mesh.Mesh.Topology, 0.1)

solid.Shape = shape
solid.Placement.Base = App.Vector(15, 0, 0)
solid.purgeTouched()
doc.recompute()
}}


{{Docnav
{{Docnav

Revision as of 21:05, 18 September 2020

Part ShapeFromMesh‏‎

Menüeintrag
Part → Shape from Mesh
Arbeitsbereich
Part
Standardtastenkürzel
Keiner
Eingeführt in Version
-
Siehe auch
Keiner

Introduction

The Part ShapeFromMesh command creates a shape from a mesh object. Mesh objects have limited editing capabilities in FreeCAD, converting them to shapes will allow their use with many more tools in FreeCAD.

Usage

  1. Select the mesh object in the tree view.
  2. Go to the menu, Part → Create shape from mesh.
  3. A popup-menu will ask for the tolerance for sewing shape; the default value is 0.1.
  4. A shape from the mesh object is created as a separate new object.

Analyzing and repairing of the mesh, if needed, should be done manually before launching ShapeFromMesh. Appropriate tools for this task are available in the Mesh Workbench.

After creation of a Shape, it may be useful to use Convert to solid (necessary for boolean operations) and Refine shape.

Links

Scripting

Creating a Shape from a Mesh can be done by using the makeShapeFromMesh method from a Part TopoShape; you need to specify the source mesh and tolerance, and assign the result to a new Part Feature object.

Notice that the mesh must be recalculated before it is converted to a Shape, otherwise there won't be topology information, and the conversion won't be successful.

import FreeCAD as App
import Part

doc = App.newDocument()
mesh = doc.addObject("Mesh::Cube", "Mesh")
mesh.recompute()

solid = doc.addObject("Part::Feature", "Shape")
shape = Part.Shape()
shape.makeShapeFromMesh(mesh.Mesh.Topology, 0.1)

solid.Shape = shape
solid.Placement.Base = App.Vector(15, 0, 0)
solid.purgeTouched()
doc.recompute()